#ifndef __Executor__
#define __Executor__
#include <vector>

#include "CqEventData.hpp"
#include "RdmaEndpointGroup.hpp"
#include "TaskThread.hpp"
#include "Logger.hpp"

class Executor
{
    int _size{0};
    std::vector<TaskThread *> _taskThreads{NULL};
    ConcurrentQueue *_taskQueue{NULL};

public:
    Executor(int size);
    void createThreads(std::unordered_map<uint32_t, RdmaRepEndpoint *> *clientRepMap,
                        std::unordered_map<uint32_t, RdmaRepEndpoint *> *serverRepMap,
                       std::unordered_map<uint32_t, RdmaSalEndpoint *> *salMap);
    void submit(struct ibv_wc *task);
    void getTask();
    void stop();
};
// long affinities[]
#endif