#ifndef __RDMA_ENDPOINT_GROUP__
#define __RDMA_ENDPOINT_GROUP__
#include <rdma/rdma_cma.h>
#include <rdma/rdma_verbs.h>
#include <stdint.h>
#include <thread>
#include <netdb.h>
#include <arpa/inet.h>
#include <map>
#include <vector>
#include <mutex>
#include <shared_mutex>
#include "RdmaSalEndpoint.hpp"
#include "RdmaRepEndpoint.hpp"
#include "Logger.hpp"


class RdmaEndpointGroup
{
public:
    std::vector<RdmaSalEndpoint *> _salEps;
    std::unordered_map<uint32_t, RdmaSalEndpoint *> _qpSalEndpointMap;

    virtual void processCmEvent(struct rdma_cm_event *event) = 0;
};
#endif