#ifndef __RdmaServerRepEndpoint__
#define __RdmaServerRepEndpoint__

#include <rdma/rdma_cma.h>
#include <rdma/rdma_verbs.h>
#include <stdint.h>
#include <errno.h>
#include <iostream>
#include <rocksdb/db.h>
#include "RdmaEndpoint.hpp"
#include "MessageFormats.hpp"
#include "Logger.hpp"
#include "RdmaRepEndpoint.hpp"

class RdmaServerRepEndpoint  : public RdmaRepEndpoint
{
public:
    static int CONN_STATE_INITIALIZED;
    static int CONN_STATE_RESOURCES_ALLOCATED;
    static int CONN_STATE_CONNECTED;
    static int CONN_STATE_CLOSED;
    int _state{0};

    struct ibv_cq *_completionQueue{NULL};
    
    RdmaServerRepEndpoint(struct rdma_cm_id *id, struct ibv_cq *completionQueue, int sendQueueSize,
                    int recvQueueSize, int sendMsgSize, int recvMsgSize,rocksdb::DB *_db);
    void createResources();
    void processCmEvent(struct rdma_cm_event *event);
    void processCqEvent(struct ibv_wc wc);
    void close();
};
#endif