#ifndef __TaskThread__
#define __TaskThread__

#include <iostream>
#include <queue>
#include <pthread.h>

#include "Runnable.hpp"
#include "CqEventData.hpp"
#include "MessageFormats.hpp"
#include "Logger.hpp"
#include "ConcurrentQueue.hpp"
#include "RdmaRepEndpoint.hpp"
#include "RdmaSalEndpoint.hpp"

class TaskThread
{

private:
    ConcurrentQueue *_taskQueue;
    bool _stop{false};
    int _id;
    pthread_t thread;
    std::unordered_map<uint32_t, RdmaRepEndpoint *> *_clientRepMap;
    std::unordered_map<uint32_t, RdmaRepEndpoint *> *_serverRepMap;
    std::unordered_map<uint32_t, RdmaSalEndpoint *> *_salMap;

public:
    TaskThread(int id, int cpu, ConcurrentQueue *,
               std::unordered_map<uint32_t, RdmaRepEndpoint *> *clientRepMap,
               std::unordered_map<uint32_t, RdmaRepEndpoint *> *serverRepMap,
               std::unordered_map<uint32_t, RdmaSalEndpoint *> *salMap);

    void replicateSalRequest(char *salRequest, uint32_t size);
    static void *run(void *object);
    void stop();
    void processEvent(RdmaSalEndpoint* ep,struct ibv_wc *data);
    void processRepEvent(RdmaRepEndpoint* ep,struct ibv_wc *data);
    ~TaskThread();
};

#endif