#include "Executor.hpp"
Executor::Executor(int size)
    : _size(size)
{
    _taskQueue = new ConcurrentQueue();
    // _taskThreads = new std::vector<TaskThread *>();
    _taskThreads.reserve(size);
}
void Executor::createThreads(std::unordered_map<uint32_t, RdmaRepEndpoint *> *clientRepMap,
                             std::unordered_map<uint32_t, RdmaRepEndpoint *> *serverRepMap,
                             std::unordered_map<uint32_t, RdmaSalEndpoint *> *salMap)
{
    for (int i = 0; i < _size; i++)
    {
        TaskThread *thread = new TaskThread(i, i, _taskQueue, clientRepMap,serverRepMap, salMap);
        _taskThreads.push_back(thread);
    }
}

void Executor::submit(struct ibv_wc *task)
{
    _taskQueue->push(task);
}
void Executor::getTask()
{
}
void Executor::stop()
{
    for (size_t i = 0; i < _taskThreads.size(); i++)
    {
        _taskThreads[i]->stop();
        delete _taskThreads[i];
    }
    delete _taskQueue;
}
